<template>
  <div class="customerManage" style="display:flex;height:calc(100% - 20px);flex-direction:column;">
    <div class="tools" style="border:none;">
      <div class="tools-item">
        <h1>月度引流统计</h1>
      </div>
      <div style="width: 340px;">
        <el-date-picker v-model="msg.month" type="year" icon="el-icon-date" slot="append" class="input-with-select"
          format="yyyy 年" @change="changeMonthHandler" placeholder="选择查询的月份">
        </el-date-picker>
      </div>
      <div class="rightmenu">
        <el-dropdown @command="handleCommand">
          <el-button class="crm-btn crm-btn-more easy-btn margin-right0">
            <i class="iconfont icongengduo"></i>
          </el-button>
          <el-dropdown-menu slot="dropdown">
            <el-dropdown-item command="1"><i class="iconfont icondaochu"></i> 导出</el-dropdown-item>
          </el-dropdown-menu>
        </el-dropdown>
      </div>
    </div>
    <el-tabs v-model="activeName" style="flex:1;height:100%;" class="diy-eltabs" tab-position="top">
      <el-tab-pane label="月度数据" name="monthdata" style="background:#000">
        <div class="data-box-item">
          <el-table :data="tableData" tooltip-effect="dark" v-loading="loading" style="width: 100%;" height="100%"
            border :cell-class-name="tableCellClassName" :row-class-name="tableRowClassName">
            <el-table-column>
              <template slot-scope="scope">
                <template v-if="scope.row.MonthStr>0">
                  <span class="pointer" style="color:blue;text-decoration:underline;"
                    @click="seeDetails(scope.row)">{{scope.row.DateStr}}</span>
                </template>
                <template v-else>
                  <span>{{scope.row.DateStr}} </span>
                </template>
              </template>
            </el-table-column>
            <el-table-column prop="PushCount" label="引流总数">
            </el-table-column>
            <el-table-column prop="EffectiveCount" label="有效总数">
            </el-table-column>
            <el-table-column prop="InvalidCount" label="无效总数">
            </el-table-column>
            <el-table-column prop="RedBookCount" label="小红书总数">
            </el-table-column>
            <el-table-column prop="DouYinCount" label="抖音总数">
            </el-table-column>
            <el-table-column prop="FlyingPigCount" label="飞猪总数">
            </el-table-column>
            <el-table-column prop="GroupChatCount" label="社群聊天总数">
            </el-table-column>
            <el-table-column prop="OfflineVisitCount" label="线下拜访总数">
            </el-table-column>
            <el-table-column prop="StraightCustomerCount" label="直客介绍总数">
            </el-table-column>
            <el-table-column prop="PeerCount" label="同业介绍总数">
            </el-table-column>
            <el-table-column prop="OtherCount" label="其他介绍总数">
            </el-table-column>
            <el-table-column prop="OrderCount" label="订单总数">
            </el-table-column>
            <el-table-column prop="TicketOrderCount" label="机票订单总数">
            </el-table-column>
            <el-table-column prop="VisaOrderCount" label="签证订单总数">
            </el-table-column>
            <el-table-column prop="GroundOrderCount" label="地接订单总数">
            </el-table-column>
            <el-table-column prop="ComboOrderCount" label="套餐订单总数">
            </el-table-column>
          </el-table>
        </div>
      </el-tab-pane>
      <el-tab-pane label="月度成长率" name="monthrate">
        <div class="data-box-item">
          <el-table :data="rateData" :formatter="formatter" tooltip-effect="dark" v-loading="rateLoading"
            style="width: 100%;" height="100%" border :cell-class-name="tableCellClassName"
            :row-class-name="tableRowClassName">
            <el-table-column prop="ItemName" label="">
            </el-table-column>
            <el-table-column prop="JanuaryRate" label="1月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="FebruaryRate" label="2月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="MarchRate" label="3月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="AprilRate" label="4月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="MayRate" label="5月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="JuneRate" label="6月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="JulyRate" label="7月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="AugustRate" label="8月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="SeptemberRate" label="9月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="OctoberRate" label="10月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="NovemberRate" label="11月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="DecemberRate" label="12月" :formatter="formatter">
            </el-table-column>
            <el-table-column prop="AvgRate" label="平均" :formatter="formatter">
            </el-table-column>
          </el-table>
        </div>
      </el-tab-pane>
    </el-tabs>
    <el-drawer :with-header="false" size='70%' :visible.sync="drawer" direction="rtl" :before-close="handleClose">
      <clueComponent :isDrawer="isDrawer" :queryTime="queryTime"></clueComponent>
    </el-drawer>
  </div>
</template>

<script>
  import clueComponent from "@/components/clueManagement/clueComponent";
  export default {
    components: {
      clueComponent
    },
    data() {
      return {
        queryTime: {
          StartTime: '',
          EndTime: ''
        },
        drawer: false,
        isDrawer: true,
        msg: {
          month: "",
          YearStr: "",
        },
        total: 0,
        tableData: [],
        loading: false,
        rateLoading: false,
        activeName: "monthdata",
        rateData: [],
      };
    },
    created() {
      let d = new Date();
      this.msg.month = d;
      this.msg.YearStr = d.getFullYear();
    },
    mounted() {
      this.init();
      this.initRate();
    },
    methods: {
      handleClose(done) {
        done();
      },
      // 查看详情
      seeDetails(row) {
        var d = new Date();
        var currentY = this.msg.YearStr;
        var currentM = this.msg.month;
        if (row.DateStr.length == 2) {
          currentM = '0' + row.DateStr.slice(0, 1)
        } else {
          currentM = row.DateStr.slice(0, 2)
        }
        var MonthDayNum = new Date(currentY, currentM, 0).getDate(); //计算当月的天数
        this.queryTime.StartTime = this.msg.YearStr + '-' + currentM + '-01'
        this.queryTime.EndTime = currentY + '-' + currentM + '-' + MonthDayNum
        this.drawer = true
      },
      init() {
        if (this.loading) return;
        this.loading = true;
        this.apipost(
          "/api/ClueStatic/GetClueMonth",
          this.msg,
          (res) => {
            this.loading = false;
            this.tableData = res.data.data;
          },
          (e) => {
            this.loading = false;
          }
        );
      },
      initRate() {
        if (this.rateLoading) return;
        this.rateLoading = true;
        this.apipost(
          "/api/ClueStatic/GetClueMonthRate",
          this.msg,
          (res) => {
            this.rateLoading = false;
            this.rateData = res.data.data;
          },
          (e) => {
            this.rateLoading = false;
          }
        );
      },
      tableRowClassName({
        row
      }) {
        let cname = "font-size-12";
        if (row.DateStr == "平均") {
          cname += " xiaoji-row";
        } else if (row.DateStr == "总数") {
          cname += " sum-row";
        }
        return cname;
      },
      tableCellClassName({
        row,
        column
      }) {
        if (
          row[column.property] && row[column.property].toString().indexOf("-") != -1 &&
          column.property != "DateStr"
        ) {
          return "warning-col";
        } else if (column.property == "InvalidCount") {
          if (
            parseFloat(row[column.property]) / parseFloat(row.PushCount) >=
            0.2
          ) {
            return "warning-col";
          }
        }
      },
      changeMonthHandler(val) {
        this.msg.YearStr = val.getFullYear();
        this.init();
        this.initRate();
      },
      formatter(row, column) {
        return row[column.property] + "%";
      },
      handleCommand(command) {
        if (command == "1") {
          if (this.activeName == "monthdata") {
            this.downloadHandler(
              "/api/ClueStatic/DownLoadClueMonth",
              "月度引流数据"
            );
          } else {
            this.downloadHandler(
              "/api/ClueStatic/DownLoadClueMonthRate",
              "月度引流成长率"
            );
          }
        }
      },
      downloadHandler(url, name) {
        this.GetLocalFile(url, this.msg, `${name}.xls`, (res) => {
          this.$message({
            message: "导出成功",
            type: "success",
          });
        });
      },
    },
  };
</script>

<style>
  @import "../../assets/css/customerManage.css";

  .el-table__fixed-body-wrapper table {
    padding-bottom: 8px !important;
  }

  .el-table .xiaoji-row {
    background: #ffff00;
  }

  .el-table .sum-row {
    background: #00b0f0;
  }

  .el-table .warning-col {
    background: red;
  }

  .diy-eltabs .el-tabs__content {
    height: calc(100% - 40px);
  }

  .diy-eltabs .data-box-item {
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
  }

  .pointer {
    cursor: pointer;
  }

  .pointer:hover {
    color: #00b0f0;
  }
</style>